#
# Makefile Template for Tessy
# Compiler   : Metrowerks HC08
# Environment: Codewarrior (Freescale Semiconductor, Inc.)
#

# Defines to be generated by Tessy:
#
# TESSY_SYS					:=
# MODULE_PATH				:=
# TESTOBJECT				:=
# USER_LINK_OPTIONS		:=
# COMPILER_INSTALL_PATH	:=
# TARGET_INSTALL_PATH	:=

#####################################################################
#BEGIN_DEFINES
#####################################################################

TESSY_SYS_DOS		:=	$(shell cygpath -w $(TESSY_SYS))
MODULE_PATH_DOS	:=	$(shell cygpath -w $(MODULE_PATH))
METROWERKS_HOME	:= $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')

TS_NAME				:= TS_CODEWARRIOR
IDE_NAME				:= codewarrior
COMPANY_NAME		:= metrowerks
PROCESSOR_NAME		:= hc08
BINARY_POSTFIX    := .abs

all	 : master slave
master : $(MODULE_PATH)\ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX)


#

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE		:=	$(TESSY_SYS)/make/master_$(IDE_NAME)_gnu_i386.mk
S_COMM_MAKE		:=	$(TESSY_SYS)/src/comm/comm_$(IDE_NAME)_$(COMPANY_NAME)_$(PROCESSOR_NAME).mk


#
#
# SLAVE
#
S_CC				:=	$(METROWERKS_HOME)\prog\chc08.exe
S_LINK			:=	$(METROWERKS_HOME)\prog\linker.exe
S_INCLUDES		:= -I$(TESSY_SYS_DOS)\include\tessy\comm -I$(MODULE_PATH_DOS)
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs$(OBJECT_POSTFIX)
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr$(OBJECT_POSTFIX)
S_COMP_OPTIONS := -W2 -WmsgNu=abcde -Cs08 -F2 -Ms -D__NO_FLOAT__ -DTESSY -DTS_SLAVE -DTS_HCS08
S_LINK_OPTIONS	:= -W1 -WmsgNu=abcde -M

#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH_DOS)\ts_src*$(OBJECT_POSTFIX)
# USER_COMP_OPTIONS* :=
# S_C1_OBJECTS       := $(MODULE_PATH)/ts_c1c01$(OBJECT_POSTFIX) ... ts_c1cnn.$(OBJECT_POSTFIX)
#
# $(MODULE_PATH_DOS)\ts_src*$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_src*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS) -ObjN="$@" $<
#
# $(MODULE_PATH)/ts_c1c*$(OBJECT_POSTFIX) : $(MODULE_PATH)/ts_c1c*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS) -ObjN="$@" $<
#
#####################################################################
#BEGIN_TARGETS
#####################################################################

# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -ObjN="$@" $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -ObjN="$@" $<


#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)


#
#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) -ObjN=$@ $<


$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) \
																			$(S_SRC_OBJECTS) \
																			$(S_UC_OBJECT) \
																			$(S_STUB_OBJECT) \
																			$(S_C1_OBJECTS) \
																			$(S_OBJECTS)
	@echo *
	@echo ***** Linking Slave *****
	@echo LINK $@ > $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo NAMES >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@sh -c 'for f in $(S_SRC_OBJECTS); do echo "$$f" >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm; done'
	@echo $(S_UC_OBJECT) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(S_STUB_OBJECT) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@sh -c 'for f in $(S_C1_OBJECTS); do echo "$$f" >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm; done'
	@echo $(MODULE_PATH_DOS)\tslows_$(IDE_NAME)$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\tstcomm$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\tscoml$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
ifdef S_COM_OBJECTS
	@echo $(MODULE_PATH_DOS)\check_driver_init$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\check_driver_layers$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\check_driver_layer_one$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\check_driver_layer_two$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(MODULE_PATH_DOS)\check_driver_layer_three$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
endif
	@echo $(METROWERKS_HOME)\lib\hc08c\lib\ansis.lib >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo $(PROJECTROOT)\cw_sample_project\cw_sample_project_Data\Standard\ObjectCode\start08.c.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@echo END  >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
	@type $(LINKER_FILE) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm

	$(S_LINK) $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm $(S_LINK_OPTIONS) $(USER_LINK_OPTIONS)
	@-rm "$(MODULE_PATH)"/*$(OBJECT_POSTFIX)

#	@echo $(METROWERKS_HOME)\lib\hc08c\lib\start08$(OBJECT_POSTFIX) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).prm
#####################################################################
#END_TARGETS
#####################################################################
